﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Office.Interop.Word;


namespace myCode
{
    /// <summary>
    /// Class1 的摘要说明
    /// </summary>
    public class ExamExportClass
    {
        public ExamExportClass()
        {

        }

        Microsoft.Office.Interop.Word.Application wApp = null;
        Microsoft.Office.Interop.Word.Document wDoc = null, oDoc = null;
        Microsoft.Office.Interop.Word.Documents Docs = null;
        private object strTemplate = "";
        private object oEndOfDoc = "\\endofdoc";
        object oMissing = System.Reflection.Missing.Value;

        public void AddDocuments()
        {

            //创建一个word文档
            wApp = new Microsoft.Office.Interop.Word.Application();
            wDoc = new Microsoft.Office.Interop.Word.Document();
            wApp.Caption = "Word导出文档";//文档副标题
            wApp.Visible = false;//显示word文档     


            wDoc = wApp.Documents.Add(ref oMissing, ref oMissing, ref oMissing, ref oMissing);
            Docs = wApp.Documents;


            object page = Microsoft.Office.Interop.Word.WdPageNumberAlignment.wdAlignPageNumberCenter;
            object firstPage = true;
           //将纸张的尺寸设置成A4
            wApp.ActiveDocument.PageSetup.PageWidth = wApp.CentimetersToPoints(float.Parse("21.0"));//纸张宽度
            wApp.ActiveDocument.PageSetup.PageHeight = wApp.CentimetersToPoints(float.Parse("29.7"));//纸张高度
            wApp.Selection.Sections[1].Footers[Microsoft.Office.Interop.Word.WdHeaderFooterIndex.wdHeaderFooterPrimary].PageNumbers.Add(ref page, ref firstPage);
        }

        public void Work()
        {
            AddDocuments();

            #region 标题
            wApp.Selection.Font.Size = 18;
            wApp.Selection.Font.Bold = 0;
            wApp.Selection.Font.Name = "黑体";
            wApp.Selection.ParagraphFormat.Alignment = Microsoft.Office.Interop.Word.WdParagraphAlignment.wdAlignParagraphCenter;
            wApp.Selection.TypeText("数据库说明列表");
            #endregion



        }
   


        #region 保存方法
        /// <summary>
        /// 保存方法
        /// </summary>
        /// <param name="filename"> </param>
        public void SaveDoc(ref object filename)
        {
            wDoc.SaveAs(ref filename, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing);
            wDoc.Close(ref oMissing, ref oMissing, ref oMissing);
            wApp.Quit(ref oMissing, ref oMissing, ref oMissing);

        }
        #endregion

    }
}