﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;

using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;


namespace myCode
{
    public partial class Form1 : Form
    {
        public static string Connect = string.Empty;

        #region Form1
        public Form1()
        {
            InitializeComponent();
        }
        #endregion

        #region 加载表名
        public void InitialTree(string connection)
        {
            if (!string.IsNullOrEmpty(connection))
            {
                SqlConnection conn = new SqlConnection(connection);
                SqlCommand comd = new SqlCommand("select * from sysobjects where type='u' and name<>'dtproperties'", conn);
                SqlDataAdapter adapter = new SqlDataAdapter(comd);
                DataTable dt_list = new DataTable();
                adapter.Fill(dt_list);
                if (dt_list != null && dt_list.Rows.Count > 0)
                {
                    this.listBox1.Sorted = true;
                    this.listBox1.DataSource = dt_list;
                    this.listBox1.DisplayMember = "name";
                    this.listBox1.ValueMember = "id";
                }
                this.lv_Columns.Items.Clear();
                if (dt_list != null && dt_list.Rows.Count > 0)
                {
                    if (this.listBox1.Items.Count > 0)
                    {
                        string strTableName = this.listBox1.Text.Trim();
                        InitialColumns(strTableName);
                    }
                }
            }
        }
        #endregion

        #region 添加连接
        private void 添加连接ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            formConnection f = new formConnection();
            f.ShowDialog();
            InitialTree(Connect);
        }
        #endregion

        #region 点击表名，获取列信息
        private void listBox1_Click(object sender, EventArgs e)
        {
            if (this.listBox1.Items.Count > 0)
            {
                string strTableName = this.listBox1.Text.Trim();
                InitialColumns(strTableName);
            }
        }

        private void InitialColumns(string strTableName)
        {
            using (SqlConnection con = new SqlConnection(Connect))
            {
                string strSql = "SELECT  TableName=CASE WHEN C.column_id=1 THEN O.name ELSE N'' END, TableDesc=ISNULL(CASE WHEN C.column_id=1 THEN PTB.[value] END,N''), Column_id=C.column_id, columns=C.name,  PrimaryKey=ISNULL(IDX.PrimaryKey,N''), [IDENTITY]=CASE WHEN C.is_identity=1 THEN N'√'ELSE N'' END,    Computed=CASE WHEN C.is_computed=1 THEN N'√'ELSE N'' END,    columntype=T.name,    Length=C.max_length,    Precision=C.precision,    Scale=C.scale,    NullAble=CASE WHEN C.is_nullable=1 THEN N'√'ELSE N'' END,    [Default]=ISNULL(D.definition,N''),    ColumnDesc=ISNULL(PFD.[value],N''),    IndexName=ISNULL(IDX.IndexName,N''),    IndexSort=ISNULL(IDX.Sort,N''),    Create_Date=O.Create_Date,    Modify_Date=O.Modify_date FROM sys.columns C    INNER JOIN sys.objects O     ON C.[object_id]=O.[object_id]            AND O.type='U'            AND O.is_ms_shipped=0    INNER JOIN sys.types T       ON C.user_type_id=T.user_type_id    LEFT JOIN sys.default_constraints D        ON C.[object_id]=D.parent_object_id            AND C.column_id=D.parent_column_id            AND C.default_object_id=D.[object_id]    LEFT JOIN sys.extended_properties PFD        ON PFD.class=1             AND C.[object_id]=PFD.major_id             AND C.column_id=PFD.minor_id    LEFT JOIN sys.extended_properties PTB        ON PTB.class=1             AND PTB.minor_id=0             AND C.[object_id]=PTB.major_id    LEFT JOIN    (        SELECT             IDXC.[object_id],            IDXC.column_id,            Sort=CASE INDEXKEY_PROPERTY(IDXC.[object_id],IDXC.index_id,IDXC.index_column_id,'IsDescending')                WHEN 1 THEN 'DESC' WHEN 0 THEN 'ASC' ELSE '' END,            PrimaryKey=CASE WHEN IDX.is_primary_key=1 THEN N'√'ELSE N'' END,            IndexName=IDX.Name        FROM sys.indexes IDX        INNER JOIN sys.index_columns IDXC            ON IDX.[object_id]=IDXC.[object_id]                AND IDX.index_id=IDXC.index_id        LEFT JOIN sys.key_constraints KC            ON IDX.[object_id]=KC.[parent_object_id]  AND IDX.index_id=KC.unique_index_id        INNER JOIN    (  SELECT [object_id], Column_id, index_id=MIN(index_id)      FROM sys.index_columns           GROUP BY [object_id], Column_id    ) IDXCUQ         ON IDXC.[object_id]=IDXCUQ.[object_id]         AND IDXC.Column_id=IDXCUQ.Column_id   AND IDXC.index_id=IDXCUQ.index_id  ) IDX    ON C.[object_id]=IDX.[object_id]     AND C.column_id=IDX.column_id WHERE O.name=N'" + strTableName + "' ORDER BY O.name,C.column_id";
                con.Open();
                SqlCommand cmd = new SqlCommand(strSql, con);
                SqlDataAdapter adapter = new SqlDataAdapter(cmd);
                DataTable dt = new DataTable();
                adapter.Fill(dt);
                this.lv_Columns.Items.Clear();
                this.cmbCondition.Items.Clear();
                if (dt != null && dt.Rows.Count > 0)
                {
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {
                        string[] subitem = new string[8];
                        subitem[0] = (i + 1).ToString();
                        subitem[1] = dt.Rows[i]["columns"].ToString();

                        subitem[2] = dt.Rows[i]["columntype"].ToString();
                        //if the datatype is nvarchar or nchar the current length=current/2
                        if ((subitem[1].ToLower() == "nvarchar") || (subitem[1].ToLower() == "nchar"))
                        {
                            int intLenth = Convert.ToInt32(dt.Rows[i]["length"].ToString());
                            intLenth = intLenth / 2;
                            subitem[3] = intLenth.ToString();
                        }
                        else
                        {
                            subitem[3] = dt.Rows[i]["length"].ToString();
                        }
                        subitem[4] = dt.Rows[i]["ColumnDesc"].ToString();
                        subitem[5] = !string.IsNullOrEmpty(dt.Rows[i]["primarykey"].ToString()) ? "是" : "否";
                        subitem[6] = !string.IsNullOrEmpty(dt.Rows[i]["NullAble"].ToString()) ? "是" : "否";
                        subitem[7] = dt.Rows[i]["Default"].ToString();
                        ListViewItem item = new ListViewItem(subitem, 0);
                        this.lv_Columns.Items.Add(item);
                        this.lv_Columns.Items[i].Checked = true;
                        this.cmbCondition.Items.Add(dt.Rows[i]["columns"].ToString());
                    }
                }
            }
        }
        #endregion

        #region 全选/取消
        private void lv_Columns_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            if (this.lv_Columns.Items.Count > 0)
            {
                if (e.Column == 0)
                {
                    bool IsCheck = this.lv_Columns.Items[0].Checked;
                    if (IsCheck)
                    {
                        for (int i = 0; i < this.lv_Columns.Items.Count; i++)
                        {
                            this.lv_Columns.Items[i].Checked = false;
                        }
                    }
                    else
                    {
                        for (int i = 0; i < this.lv_Columns.Items.Count; i++)
                        {
                            this.lv_Columns.Items[i].Checked = true;
                        }
                    }
                }
            }
        }
        #endregion

        #region 生成
        private void btnOk_Click(object sender, EventArgs e)
        {
            if (this.listBox1.Items.Count > 0)
            {
                if (string.IsNullOrEmpty(this.cmbOpType.Text))
                {
                    MessageBox.Show("请选择操作类型");
                    return;
                }
                string strTableName = this.listBox1.Text.Trim();
                List<ColumnsInfo> list = getSelect();
                DBTableInfo dtinfo = new DBTableInfo(strTableName, list);
                string Result = string.Empty;

                #region Select Sql
                if (this.cmbOpType.Text.Trim() == "查询")
                {
                    if (!string.IsNullOrEmpty(this.cmbCondition.Text.Trim()))
                    {
                        Result = getSelectSql(this.cmbCondition.Text, this.txtConditionDesc.Text.Trim(), dtinfo);
                    }
                    else
                    {
                        MessageBox.Show("操作为查询时，请选择参数列");
                        return;
                    }
                }
                #endregion

                #region AddSql
                if (this.cmbOpType.Text.Trim() == "添加")
                {
                    Result = getAddSql(dtinfo);
                }
                #endregion

                #region UpdateSql
                if (this.cmbOpType.Text.Trim() == "修改")
                {
                    List<ColumnsInfo> columnsList = getAllColumns();
                    Result = getUpdateSql(this.cmbCondition.Text, this.txtConditionDesc.Text.Trim(), dtinfo, columnsList);

                }
                #endregion

                #region DeleteSql
                if (this.cmbOpType.Text.Trim() == "删除")
                {
                    Result = getDeleteSql(this.cmbCondition.Text, this.txtConditionDesc.Text.Trim(), dtinfo);
                }
                #endregion

                #region EntityClass Sql
                if (this.cmbOpType.Text.Trim() == "实体类")
                {
                    if (string.IsNullOrEmpty(this.txtNameSpace.Text.Trim()))
                    {
                        MessageBox.Show("请输入命名空间");
                    }
                    else
                    {
                        Result = getEntity(list, strTableName);
                    }
                }
                #endregion

                #region insertSql
                if (this.cmbOpType.Text.Trim() == "生成Insret语句")
                {

                    if (string.IsNullOrEmpty(strTableName))
                    {
                        MessageBox.Show("请选择所生成的表！");
                        return;
                    }
                    DataTable dt_list = getList(dtinfo.TableName.ToString());
                    List<ColumnsInfo> columnsList = getAllColumns();
                    List<string> listResult = GetInsertSql(dt_list, dtinfo.TableName.ToString(), columnsList);
                    for (int i = 0; i < listResult.Count; i++)
                    {
                        Result += listResult[i];
                    }
                }
                #endregion

                if (this.cmbOpType.Text.Trim() == "生成说明文档")
                {
                    MyCode.WordExportForm f = new MyCode.WordExportForm();

                    f.ShowDialog();
                    return;
                }

                if (!string.IsNullOrEmpty(Result))
                {
                    MessageBox.Show("已将内容复制到剪切板，请使用粘贴获取代码");
                    Clipboard.SetText(Result);
                }
                else
                {
                    MessageBox.Show("参数错误");
                }
            }


        }
        #endregion

        #region  生成添加的sql语句
        string getAddSql(DBTableInfo dbinfo)
        {
            string strResult = "string strSql=\" insert into " + dbinfo.TableName + "(";

            for (int i = 0; i < dbinfo.List.Count; i++)
            {
                strResult += dbinfo.List[i].ColumnsName.ToString() + ",";
            }
            strResult = strResult.Trim(new char[] { ',' });
            strResult += ")";
            strResult += "values(";
            for (int i = 0; i < dbinfo.List.Count; i++)
            {
                strResult += "@" + dbinfo.List[i].ColumnsName.ToString() + ",";
            }
            strResult = strResult.Trim(new char[] { ',' });
            strResult += ") \";";
            strResult += "\n";
            strResult += " SqlParameter[] parameters = new SqlParameter[]\n{\n";
            string strTempColumns = string.Empty;
            for (int j = 0; j < dbinfo.List.Count; j++)
            {
                strTempColumns += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "," + dbinfo.List[j].ColumnsLength.ToString() + "),\n";

            }
            strTempColumns = strTempColumns.Trim(new char[] { ',', '\n' });
            strResult += strTempColumns;
            strResult += "\n};\n\r";
            //
            for (int i = 0; i < dbinfo.List.Count; i++)
            {
                strResult += "parameters[" + i + "].Value=;\n\r";
            }
            return strResult;
        }
        #endregion

        #region 获取所有列名信息
        /// <summary>
        /// 获取所有列名信息
        /// </summary>
        /// <returns></returns>
        List<ColumnsInfo> getAllColumns()
        {
            List<ColumnsInfo> list = new List<ColumnsInfo>();
            for (int i = 0; i < this.lv_Columns.Items.Count; i++)
            { //列名
                string columnsname = lv_Columns.Items[i].SubItems[1].Text.Trim();
                string columnstype = lv_Columns.Items[i].SubItems[2].Text.Trim();
                int columnslenth = int.Parse(lv_Columns.Items[i].SubItems[3].Text.Trim());
                ColumnsInfo coinfo = new ColumnsInfo(columnsname, columnstype, columnslenth);
                list.Add(coinfo);
            }
            return list;
        }
        #endregion

        #region 获取列名信息
        List<ColumnsInfo> getSelect()
        {
            List<ColumnsInfo> list = new List<ColumnsInfo>();
            for (int i = 0; i < this.lv_Columns.Items.Count; i++)
            {
                if (this.lv_Columns.Items[i].Checked)
                {
                    //列名
                    string columnsname = lv_Columns.Items[i].SubItems[1].Text.Trim();
                    string columnstype = lv_Columns.Items[i].SubItems[2].Text.Trim();
                    int columnslenth = int.Parse(lv_Columns.Items[i].SubItems[3].Text.Trim());
                    ColumnsInfo coinfo = new ColumnsInfo(columnsname, columnstype, columnslenth);
                    list.Add(coinfo);
                }
            }
            return list;
        }
        #endregion

        #region 返回查询的sql语句
        string getSelectSql(string ConditionColumns, string InputCondition, DBTableInfo dbinfo)
        {
            string Result = string.Empty;
            Result = "string strSql=\" select ";

            //循环dbInfo
            for (int i = 0; i < dbinfo.List.Count; i++)
            {
                Result += dbinfo.List[i].ColumnsName + ",";
            }
            Result = Result.Trim(new char[] { ',' });
            Result += " from " + dbinfo.TableName;
            Result += " where 1=1  and " + ConditionColumns + InputCondition + "@" + ConditionColumns;
            Result += "\";";
            Result += "\n";
            Result += " SqlParameter[] parameters = new SqlParameter[]\n{\n";
            string strTempColumns = string.Empty;
            for (int j = 0; j < dbinfo.List.Count; j++)
            {
                if (dbinfo.List[j].ColumnsName == ConditionColumns)
                {
                    strTempColumns += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "," + dbinfo.List[j].ColumnsLength.ToString() + ")\n";
                }
            }
            strTempColumns = strTempColumns.Trim(new char[] { ',', '\n' });
            Result += strTempColumns;
            Result += "\n};\n";
            Result += "parameters[0].Value=;\n\r";
            return Result;




        }
        #endregion

        #region 根据类型返回sqlDBType的类型
        string getSqlDBTypeByColumnType(string ColumnsName)
        {
            string strResult = string.Empty;
            switch (ColumnsName)
            {
                case "image":
                    strResult = SqlDbType.Image.ToString();
                    break;
                case "text":
                    strResult = SqlDbType.Text.ToString();
                    break;
                case "uniqueidentifier":
                    strResult = SqlDbType.UniqueIdentifier.ToString();
                    break;
                case "tinyint":
                    strResult = SqlDbType.TinyInt.ToString();
                    break;
                case "smallint":
                    strResult = SqlDbType.SmallInt.ToString();
                    break;
                case "int":
                    strResult = SqlDbType.Int.ToString();
                    break;
                case "smalldatetime":
                    strResult = SqlDbType.SmallDateTime.ToString();
                    break;
                case "real":
                    strResult = SqlDbType.Real.ToString();
                    break;
                case "money":
                    strResult = SqlDbType.Money.ToString();
                    break;
                case "datetime":
                    strResult = SqlDbType.DateTime.ToString();
                    break;
                case "float":
                    strResult = SqlDbType.Float.ToString();
                    break;
                case "sql_variant":
                    break;
                case "ntext":
                    strResult = SqlDbType.NText.ToString();
                    break;
                case "bit":
                    strResult = SqlDbType.Bit.ToString();
                    break;
                case "numeric":
                case "decimal":
                    strResult = SqlDbType.Decimal.ToString();
                    break;
                case "smallmoney":
                    strResult = SqlDbType.SmallMoney.ToString();
                    break;
                case "bigint":
                    strResult = SqlDbType.BigInt.ToString();
                    break;
                case "varbinary":
                    strResult = SqlDbType.VarBinary.ToString();
                    break;
                case "varchar":
                    strResult = SqlDbType.VarChar.ToString();
                    break;
                case "binary":
                    strResult = SqlDbType.Binary.ToString();
                    break;
                case "char":
                    strResult = SqlDbType.Char.ToString();
                    break;
                case "timestamp":
                    strResult = SqlDbType.Timestamp.ToString();
                    break;
                case "nvarchar":
                    strResult = SqlDbType.NVarChar.ToString();
                    break;
                case "nchar":
                    strResult = SqlDbType.NChar.ToString();
                    break;
                case "xml":
                    strResult = SqlDbType.Xml.ToString();
                    break;
                default:
                    break;
            }
            return strResult;
        }
        #endregion

        #region 获取修改的sql语句
        string getUpdateSql(string ConditionColumns, string InputCondition, DBTableInfo dbinfo, List<ColumnsInfo> columnsinfo)
        {
            string Result = string.Empty;
            Result += " string strSql=\" update " + dbinfo.TableName;
            Result += " set ";
            for (int i = 0; i < dbinfo.List.Count; i++)
            {
                Result += dbinfo.List[i].ColumnsName + "=@" + dbinfo.List[i].ColumnsName + ",";
            }
            Result = Result.Trim(new char[] { ',' });
            Result += " where 1=1 and " + ConditionColumns + InputCondition + "@1" + ConditionColumns.ToString();
            Result += " \";";
            Result += "\n\r";

            Result += " SqlParameter[] parameters = new SqlParameter[]\n{\n";
            string strTempColumns = string.Empty;
            for (int j = 0; j < dbinfo.List.Count; j++)
            {
                if (getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType).ToLower() == "nvarchar")
                {
                    strTempColumns += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "," + (dbinfo.List[j].ColumnsLength / 2).ToString() + "),\n";
                }
                else if (getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType).ToLower() == "text")
                {
                    strTempColumns += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "),\n";
                }
                else if (getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType).ToLower() == "datetime")
                {
                    strTempColumns += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "),\n";

                }
                else
                {
                    strTempColumns += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "," + dbinfo.List[j].ColumnsLength.ToString() + "),\n";
                }
            }
            //拼出where 条件之后的列，参数
            for (int i = 0; i < columnsinfo.Count; i++)
            {
                if (columnsinfo[i].ColumnsName.ToString().Trim() == ConditionColumns.Trim())
                {
                    if (getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType).ToLower() == "nvarchar")
                    {
                        strTempColumns += " new SqlParameter(\"@1" + columnsinfo[i].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType) + "," + (columnsinfo[i].ColumnsLength / 2).ToString() + ")\n";
                    }
                    else if (getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType).ToLower() == "text")
                    {
                        strTempColumns += " new SqlParameter(\"@1" + columnsinfo[i].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType) + ")\n";
                    }
                    else if (getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType).ToLower() == "datetime")
                    {
                        strTempColumns += " new SqlParameter(\"@1" + columnsinfo[i].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType) + ")\n";

                    }
                    else
                    {
                        strTempColumns += " new SqlParameter(\"@1" + columnsinfo[i].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(columnsinfo[i].ColumnsType) + "," + columnsinfo[i].ColumnsLength.ToString() + ")\n";
                    }
                }
            }
            Result += strTempColumns;
            Result += "\n};\n";
            for (int i = 0; i < dbinfo.List.Count; i++)
            {
                Result += "parameters[" + i + "].Value=;\n";
            }
            Result += "parameters[" + dbinfo.List.Count.ToString() + "].Value=;\n";
            return Result;

        }
        #endregion

        #region getDeleteSql
        string getDeleteSql(string ConditionColumns, string InputCondition, DBTableInfo dbinfo)
        {
            string Result = "string strSql=\" delete from " + dbinfo.TableName + " where 1=1 and " + ConditionColumns + InputCondition + "@" + ConditionColumns;
            Result += "\";\n";
            Result += " SqlParameter[] parameters = new SqlParameter[]\n{\n";
            for (int j = 0; j < dbinfo.List.Count; j++)
            {
                if (dbinfo.List[j].ColumnsName == ConditionColumns)
                {
                    Result += " new SqlParameter(\"@" + dbinfo.List[j].ColumnsName.ToString() + "\",SqlDbType." + getSqlDBTypeByColumnType(dbinfo.List[j].ColumnsType) + "," + dbinfo.List[j].ColumnsLength.ToString() + ")\n";
                    break;
                }
            }
            Result = Result.Trim(new char[] { ',', '\n' });
            Result += "\n};\n";
            Result += "parameters[0].Value=;\n\r";
            return Result;
        }
        #endregion

        #region 退出
        private void 退出ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult Result = MessageBox.Show("确定退出本程序？", "提示", MessageBoxButtons.OKCancel);
            if (Result == DialogResult.OK)
            {
                this.Close();
            }
            else { return; }
        }
        #endregion

        #region 关于
        private void 关于xinberCoderBate101ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutForm frmAbout = new AboutForm();
            frmAbout.ShowDialog();
        }
        #endregion

        #region 最小化
        private void Form1_Resize(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.ShowInTaskbar = false;
                notifyIcon1.Visible = true;
                this.Visible = false;
            }
        }
        #endregion

        #region 双击显示
        private void notifyIcon1_Click(object sender, EventArgs e)
        {
            this.Visible = true;
            this.WindowState = FormWindowState.Normal;
        }
        #endregion

        #region 双击托盘
        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            this.Visible = true;
            this.WindowState = FormWindowState.Normal;
        }
        #endregion

        #region 返回生成sqlInsert语句
        List<string> GetInsertSql(DataTable Table, string TableName, List<ColumnsInfo> columnsinfo)
        {
            List<string> list = new List<string>();
            string column = "";
            for (int i = 1; i < columnsinfo.Count; i++)
            {
                column += columnsinfo[i].ColumnsName + ",";
            }
            column = column.Trim(new char[] { ',' });
            string strValue = string.Empty;
            for (int i = 0; i < Table.Rows.Count; i++)
            {
                strValue = "Insert into " + TableName + "(" + column + ")values(";
                int index = 1;
                while (index <= Table.Columns.Count - 1)
                {
                    if (
                        columnsinfo[index].ColumnsType.ToLower().Contains("datetime") ||
                        columnsinfo[index].ColumnsType.ToLower().Contains("varchar") ||
                        columnsinfo[index].ColumnsType.ToLower().Contains("nvarchar") ||
                        columnsinfo[index].ColumnsType.ToLower().Contains("text") ||
                        columnsinfo[index].ColumnsType.ToLower().Contains("nchar")
                        )
                    {
                        strValue += "'" + Table.Rows[i][index].ToString().Trim() + "'" + ",";
                    }
                    else
                    {
                        if (string.IsNullOrEmpty(Table.Rows[i][index].ToString().Trim()))
                            strValue += "NULL" + ",";
                        else
                            strValue += Table.Rows[i][index].ToString().Trim() + ",";
                    }
                    index++;
                }
                strValue = strValue.Trim(new char[] { ',' });
                strValue += ");\n";
                list.Add(strValue);
            }
            return list;
        }
        #endregion

        #region 根据表名获取数据
        DataTable getList(string tableName)
        {
            DataTable dt = new DataTable();
            using (SqlConnection con = new SqlConnection(Connect))
            {
                string strSql = "select * from " + tableName;
                con.Open();
                SqlCommand cmd = new SqlCommand(strSql, con);
                SqlDataAdapter adapter = new SqlDataAdapter(cmd);
                adapter.Fill(dt);
            }
            return dt;
        }
        #endregion

        #region getColumnType
        string getColumnType(string ColumnsType)
        {
            string Result = string.Empty;
            if (
                (ColumnsType.Contains("varchar"))
                || (
                ColumnsType.Contains("char")
                )) { Result = "string "; }
            else
            {
                if (ColumnsType.Contains("numeric") || ColumnsType.Contains("decimal"))
                {
                    Result = "decimal ";
                }

                else
                {
                    switch (ColumnsType)
                    {
                        case "int":
                            Result = "int ";
                            break;
                        case "bit":
                            Result = "bool ";
                            break;
                        case "datetime":
                            Result = "DateTime ";
                            break;
                        case "float":
                            Result = "float ";
                            break;
                        case "text":
                            Result = "string ";
                            break;
                        default:
                            break;
                    }
                }
            }
            return Result;
        }
        #endregion

        #region 获取选择表的实体类
        string getEntity(List<ColumnsInfo> columnsList, string tableName)
        {
            StringBuilder sbContent = new StringBuilder();
            sbContent.Append("using System;\n");
            sbContent.Append("using System.Collections.Generic;\n");
            sbContent.Append("using System.Text;\n");
            sbContent.Append("namespace " + this.txtNameSpace.Text.Trim() + "\n{\n");
            sbContent.Append(" [Serializable]\n");
            sbContent.Append("public class " + tableName + "\n {\n");
            for (int i = 0; i < columnsList.Count; i++)
            {
                string strCurrentColumnType = getColumnType(columnsList[i].ColumnsType.ToLower().Trim());
                sbContent.Append("private " + strCurrentColumnType + " " + columnsList[i].ColumnsName.ToLower() + ";\n");
                sbContent.Append("public " + strCurrentColumnType + columnsList[i].ColumnsName.Trim() + "\n");
                sbContent.Append("{\n");
                sbContent.Append("get { return this." + columnsList[i].ColumnsName.ToLower() + "; }\n");
                sbContent.Append("set { this." + columnsList[i].ColumnsName.ToLower() + " = value; }\n");
                sbContent.Append("} \n");
            }
            sbContent.Append("\n}");
            sbContent.Append("\n}");
            return sbContent.ToString();
        }
        #endregion

        #region 提示代码
        private void 验证提示代码ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ValidateCodeForm f = new ValidateCodeForm();
            f.ShowDialog();
        }
        #endregion

        #region 加载皮肤文件
        /// <summary>
        /// 加载皮肤文件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            this.skinEngine1.SkinFile = "office2007.ssk";
        }
        #endregion

        #region 搜索
        /// <summary>
        /// 搜索
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtSearchTableName_TextChanged(object sender, EventArgs e)
        {
            if (this.listBox1.Items.Count > 0)
            {
                string strInputTableName = this.txtSearchTableName.Text.Trim().ToLower();
                int index = this.listBox1.FindString(strInputTableName, 0);
                this.listBox1.SelectedIndex = index;

                string strTableName = this.listBox1.Text.Trim();
                InitialColumns(strTableName);
            }
        }
        #endregion

        #region 更新时间
        /// <summary>
        /// 更新时间
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timer1_Tick(object sender, EventArgs e)
        {
            this.toolStripStatusLabel1.Text = "Current Date：" + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  " + DateTime.Now.Date.DayOfWeek.ToString();

        }
        #endregion

        #region Export Table to file
        /// <summary>
        /// 
        /// </summary>
        bool Export()
        {
            bool Result = false;
            try
            {
                string strFileName = this.listBox1.Text.Trim();
                //
                ExamExportClass c = new ExamExportClass();
                c.AddDocuments();
                c.Work();
                object objFileName = @"E:\Export.doc";
                c.SaveDoc(ref objFileName);
                Result = true;
            }
            catch (Exception Ex)
            {
                Result = false;
                MessageBox.Show(Ex.Message);
            }
            return Result;
        }
        #endregion

        #region MyRegion
        private void 将表生成说明文档PToolStripMenuItem_Click(object sender, EventArgs e)
        {


        }
        #endregion

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {



        }

        private void lv_Columns_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                this.contextMenuStrip1.Show(e.X + 250, e.Y + 100);
            }
        }
        #region 复制列的描述
        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            MessageBox.Show("已将内容复制到剪切板，请使用粘贴获取");
            Clipboard.SetText(this.lv_Columns.SelectedItems[0].SubItems[4].Text);
        }
        #endregion
        #region 复制数据类型
        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            MessageBox.Show("已将内容复制到剪切板，请使用粘贴获取代码");
            Clipboard.SetText(this.lv_Columns.SelectedItems[0].SubItems[2].Text);
        }
        #endregion
        #region 复制列名
        private void toolStripMenuItem4_Click(object sender, EventArgs e)
        {
            MessageBox.Show("已将内容复制到剪切板，请使用粘贴获取代码");
            Clipboard.SetText(this.lv_Columns.SelectedItems[0].SubItems[1].Text);
        }
        #endregion
        #region 刷新列表
        private void toolStripMenuItem5_Click(object sender, EventArgs e)
        {
            if (this.listBox1.Items.Count > 0)
            {
                string strTableName = this.listBox1.Text.Trim();
                InitialColumns(strTableName);
            }
        }
        #endregion

    }
}
